globals [who_list op_list op2_list op3_list v vp vpx vpy vnx vny sumpp sumnp vturtle done]
;; who_list is list of agents
;; service variables are op_list op2_list op3_list v vp vpx vpy vnx vny sumpp sumnp
directed-link-breed [red-links red-link]       ;; for visualization of teams
directed-link-breed [gray-links gray-link]     ;; for visualization of perceptions in PerRadius
turtles-own
[
;; operation attributes
  contacts_list    ;; number of turtles in PerRadius
  pers_list        ;; my perception of other turtles

  productivity     ;; my productivity
  originalcolor    ;; color at birth
;; control attributes
  head             ;; true if turtle is Head
  subordinate      ;; (for not head) trtl has actual head now (link from)
  suborders_list   ;; contacts to subordinates (for head)
  restrSbrdrs_list ;; restricted operators for the Head
  pos_strategy     ;; for calculation individual positive strategy goals
  neg_strategy     ;; for calculation individual negative strategy goals
  xpos ypos xneg yneg    ;; positive and negative strategy  goals coordinates
  my_group_productivity             ;;(for head)
  group_product_cumulative          ;;(for head)
  candidate        ;;  number of subordinate with minimal performance

]

to setup
  clear-all
  set who_list []
  set op_list []

  create-ordered-turtles quantity
  [
    ;set color yellow
    set size turt_size set shape "person"
    set label who
    set pos_strategy false
    set neg_strategy false
    set who_list lput who who_list

    setxy random-xcor random-ycor
    set pers_list []
    set contacts_list []
    set suborders_list []
    set restrSbrdrs_list []
    ifelse who < managers [set head true set color red]
                          [set head false set color blue]
    set subordinate false
    set group_product_cumulative 0
    set productivity random 100
    set originalcolor color
    set candidate -1   ;; no candidate
  ]

  show word "turtles Who" who_list ;; {------OBSERVER------}
  perception

  show "setup done!"
  reset-ticks
end
;-------------------------------------------------------------------------------------
to go

  ask gray-links [die ]                                  ;;; take off old links
  ask turtles [lt random Stoch_Motion_Speed fd random 2 * Stoch_Motion_Speed] ;;; move it stochasticaly!!!
  connect

  set_strategy_goals_wghtd
  let t 0.5
  ask turtles
  [ ;;------------------------ Realise strategy ----------------------------------------------

    if (Attraction and pos_strategy) [set xcor  (t * xpos + (1 - t) * xcor) set ycor (t * ypos + (1 - t) * ycor) ]

    if (Rejection and neg_strategy) [set xcor  ( - t * xneg + (1 + t) * xcor) set ycor (- t * yneg + (1 + t) * ycor) ]
  ]
  group_productivity

  head_behaviour

  OperatorsDecision
  team_update    ;; set candidate for elimination
  if (random 100 < PrbltyOfElimination%) [candidate_elimination]

tick
  if (ticks = 10000) [stop]
end
;-------------------------------------------------
to head_behaviour   ;;make links to suborders in op_radius
  ask turtles with [head]
  [
    set v who
    set op2_list pers_list        ;; head's perception of turtles

   set op_list suborders_list     ;; current suborders
   set op3_list restrSbrdrs_list  ;; restricted for me suborders

      if AskPOS [
        ask turtles in-radius op_radius with [(not subordinate) and (not head) and (item who op2_list > 0) and (not member? who op3_list)]
                       [
                        create-red-link-from turtle v [set color red]
                        set subordinate true
                        set op_list lput who op_list
               ;         write "Pos" write count red-links write v show op_list
                       ]
               ] ;; if AskPOS
    if AskNEG [
      ask turtles in-radius op_radius with [(not subordinate) and (not head) and (item who op2_list <= 0) and (not member? who op3_list)]
                       [
                        create-red-link-from turtle v [set color red]
                        set subordinate true
                        set op_list lput who op_list
               ;         write "Neg" write count red-links write v show op_list
                       ]
              ]  ;; if AskNEG
    set suborders_list op_list

  ]
end
;-----------------------------------------------
to team_update   ;; set candidate for elimination (turtle with min productivity)
  ask turtles with [head = true]
  [
    set op_list suborders_list
    set vp who
    write "Head" write vp show op_list
    ifelse length op_list > 1
    [
    set vturtle  min-one-of turtles with [not head and member? who op_list] [productivity]
    set v [who] of vturtle

    write "Head" write vp write "Candidate"  show v
    set candidate v
    ]
    [
      set candidate  (-1)
    ]

  ]
end
;-----------------------------------------------
to candidate_elimination

      ask turtles with [head and candidate != (-1)]
      [

        write "CandidateElimntn" write who show candidate
        set vp candidate set v who
        ask red-link v vp [die]

        set suborders_list remove vp suborders_list
        write suborders_list
        set candidate -1   ;; no candidate
        ask turtles with [who = vp] [set subordinate false write "Sub Who" write who show subordinate]
     ]

end
;-----------------------------------------------
to OperatorsDecision
 ask turtles with [subordinate]
  [
   set v who        ;;; of THIS turtle
   ask my-in-red-links [ set vturtle  other-end   ;;; Now vturtle IS TURTLE !!!!!
                         set vp [who] of vturtle  ;;; vp is now my Head's who number
                       ]

    let r  item vp pers_list
    if (r < 0) and (random 100 < PrbltyOfDecisn%)
    [
    write "RedLnkDie" write vp show v
    ask red-link vp v [die]

    set subordinate false
    ask turtles with [who = vp] [set suborders_list remove v suborders_list  set restrSbrdrs_list lput v restrSbrdrs_list]
    ]
  ]

end
;-----------------------------------------------
to set_strategy_goals_wghtd    ;; Weighted (by pers values) coord sums is goals 4 POS and NEG strategies
ask turtles
  [ set sumpp 0 set sumnp 0

    ;.....................................SUM of POS and abs(NEG) Perceptions
    if not empty? contacts_list
    [ set op_list contacts_list
      set op2_list pers_list
      let j length op_list
      let i 0
      while [i <= j - 1]
      [
        let ii item i op_list
        let r  item ii op2_list
        if (r > 0)
        [ask turtles with  [who = item i op_list]  [set sumpp sumpp + r ]
        ]
        if (r < 0)
        [ask turtles with  [who = item i op_list]  [set sumnp sumnp + abs r ]
        ]
        set i i + 1
      ]
   ]

   ;........................................... Weighted coordinates Sum

    set pos_strategy false
    set neg_strategy false
    if not empty? contacts_list
    [ set op_list contacts_list
      set op2_list pers_list  ;;;!!!!
      let j length op_list
      let i 0 let k 0 let l 0 set vpx 0 set vpy 0 set vnx 0 set vny 0
      while [i <= j - 1]
      [
        let ii item i op_list
        let r item ii op2_list
        if ( r > 0)
        [
          set pos_strategy true
          ask turtles with  [who = ii]  [set vpx vpx + xcor * (r / sumpp) set vpy vpy + ycor * (r / sumpp)]
        ]
        if ( r < 0)
        [
          set neg_strategy true
          ask turtles with  [who = ii]  [set vnx vnx + xcor * (abs r / sumnp) set vny vny + ycor * (abs r / sumnp)]
        ]
        set i i + 1
      ]
      if pos_strategy [set xpos vpx set ypos vpy

                      ]
      if neg_strategy [set xneg vnx set yneg vny

                      ]
    ]
  ]
end
;-----------------------------------------------
to connect   ;;create-gray-links-to neighbours in PerRadius
  ask turtles [create-gray-links-to other turtles in-radius PerRadius ask gray-links [set color 2 set hidden? not Gray-links-Visible]]
  ask turtles
  [
      set op_list []
      ask other turtles in-radius PerRadius
      [
           set op_list lput who op_list
      ]
      set contacts_list op_list

  ]
end
;-----------------------------------------------
to perception
  ask turtles
  [
    let i 1 set pers_list []
    while [i <= quantity]
    [set pers_list lput precision (random-normal NormMean NormStdDev) 2 pers_list set i i + 1]
  ]
  ask turtles  [ write who show [pers_list] of turtle who ]
end
;-----------------------------------------------
to InvertPerceptonOfTurtle   ;; we invert the perception of the turtle TrtlWho in the radius PerRadius
  ifelse (TrtlWho >= 0) and (TrtlWho < Quantity)
  [
     ask turtles with [who = TrtlWho]
     [
         ask other turtles in-radius PerRadius
         [
           let r (item TrtlWho pers_list)
           set pers_list  remove-item TrtlWho pers_list
           set pers_list  insert-item TrtlWho pers_list (- r)
         ]
      set restrSbrdrs_list []   ;; clear list of restricted suborders for turtle TrtlWho
     ]
  ]
  [show "Who is 0 to Quantity - 1 !!!!!"]   ;; ifelse
end
;-----------------------------------------------
to group_productivity
  ask turtles with [head]
  [
    set vpx xcor set vpy ycor set vp who
    set op_list suborders_list

    set v 0
    ask turtles with [member? who op_list] [set v v +  productivity * (59 - distancexy vpx vpy) / 59]
    set my_group_productivity  precision v 2
    set  group_product_cumulative  group_product_cumulative + v
  ]

end
;-----------------------------------------------
to show-value
  ifelse (TrtlWho >= 0) and (TrtlWho < Quantity) [set op_list [pers_list] of turtle TrtlWho  set op2_list [contacts_list] of turtle TrtlWho]
                            [show "Who is 0 to Quantity - 1 !!!!!"]
  show count red-links
  ask turtles
  [
  if subset = "PosStrategy" and pos_strategy  [set color 65]
  if subset = "NegStrategy" and neg_strategy  [set color 25]
  if subset = "OriginalColor"                 [set color originalcolor]
  if subset = "MyPercOfOthers"  [ask other turtles [if item who op_list > 0 [set color 65] ;;with [member? who op2_list] [set color 65]]
                                                 if item who op_list < 0 [set color 25]
                                                   ] ask turtle TrtlWho [set color white]
                                ]

  if subset = "PercOfMebyOthers"  [ask other turtles [if item TrtlWho pers_list > 0 [set color 65]
                                                  if item TrtlWho pers_list < 0 [set color 25]
                                                     ] ask turtle TrtlWho [set color white]
                                  ]

  if subset = "GroupProduct(Observr)"   [if head [write "Group Produtovity "show my_group_productivity
                                           if length suborders_list > 0 [write "Per operator "show precision (my_group_productivity / length suborders_list) 2]
                                        ]
                               ]
    if subset = "MySuborders(Observr)"    [if head [write "Head " show suborders_list write "Candidate " show candidate write "Restricted " show restrSbrdrs_list]]
  ]

end
@#$#@#$#@
GRAPHICS-WINDOW
283
10
855
583
-1
-1
6.8
1
12
1
1
1
0
1
1
1
-41
41
-41
41
1
1
1
ticks
30.0

BUTTON
31
68
99
101
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
181
68
249
101
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
99
68
180
101
go once
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
95
30
187
63
Quantity
Quantity
1
100
30.0
1
1
NIL
HORIZONTAL

SLIDER
2
30
94
63
turt_size
turt_size
1
5
3.0
1
1
NIL
HORIZONTAL

PLOT
880
486
1105
606
Gray / Red links
NIL
NIL
0.0
10.0
0.0
4.0
true
false
"" ""
PENS
"default" 1.0 0 -2674135 true "" "plot count red-links"
"pen-1" 1.0 0 -7500403 true "" "plot count gray-links"

CHOOSER
882
20
1061
65
subset
subset
"PosStrategy" "NegStrategy" "OriginalColor" "MyPercOfOthers" "PercOfMebyOthers" "GroupProduct(Observr)" "MySuborders(Observr)"
6

PLOT
880
119
1280
295
Total_Group_productivity
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot [my_group_productivity] of turtle 0 "
"pen-1" 1.0 0 -7500403 true "" "plot [my_group_productivity] of turtle 1 "
"pen-2" 1.0 0 -2674135 true "" "plot [my_group_productivity] of turtle 2 "
"pen-3" 1.0 0 -955883 true "" "plot [my_group_productivity] of turtle 3 "
"pen-4" 1.0 0 -6459832 true "" "plot [my_group_productivity] of turtle 4"
"pen-5" 1.0 0 -1184463 true "" "plot [my_group_productivity] of turtle 5"
"pen-6" 1.0 0 -10899396 true "" "plot [my_group_productivity] of turtle 6"

INPUTBOX
1065
21
1116
105
TrtlWho
0.0
1
0
Number

SLIDER
45
133
141
166
PerRadius
PerRadius
1
56
16.0
1
1
NIL
HORIZONTAL

SLIDER
144
133
242
166
Stoch_Motion_Speed
Stoch_Motion_Speed
0
5
0.0
1
1
NIL
HORIZONTAL

SWITCH
44
168
140
201
Attraction
Attraction
0
1
-1000

SWITCH
144
168
241
201
Rejection
Rejection
0
1
-1000

SLIDER
44
461
136
494
NormMean
NormMean
-5
5
-2.0
1
1
NIL
HORIZONTAL

SLIDER
141
461
251
494
NormStdDev
NormStdDev
0
15
3.0
1
1
NIL
HORIZONTAL

BUTTON
43
495
251
530
Update perception for all
perception
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
882
71
1059
106
ShowSubset
show-value
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
187
30
279
63
managers
managers
0
100
6.0
1
1
NIL
HORIZONTAL

SLIDER
2
222
94
255
Op_Radius
Op_Radius
0
56
19.0
1
1
NIL
HORIZONTAL

PLOT
881
298
1282
483
Group_Productivity_Per_Worker
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "if (length [suborders_list] of turtle 0 > 0)[plot ([my_group_productivity] of turtle 0 ) / length [suborders_list] of turtle 0]"
"pen-1" 1.0 0 -7500403 true "" "if (length [suborders_list] of turtle 1 > 0) [plot ([my_group_productivity] of turtle 1 ) / length [suborders_list] of turtle 1]"
"pen-2" 1.0 0 -2674135 true "" "if (length [suborders_list] of turtle 2 > 0) [plot ([my_group_productivity] of turtle 2 ) / length [suborders_list] of turtle 2]"
"pen-3" 1.0 0 -955883 true "" "if (length [suborders_list] of turtle 3 > 0) [plot ([my_group_productivity] of turtle 3 ) / length [suborders_list] of turtle 3]"
"pen-4" 1.0 0 -6459832 true "" "if (length [suborders_list] of turtle 4 > 0) [plot ([my_group_productivity] of turtle 4 ) / length [suborders_list] of turtle 4]"
"pen-5" 1.0 0 -1184463 true "" "if (length [suborders_list] of turtle 5 > 0) [plot ([my_group_productivity] of turtle 5 ) / length [suborders_list] of turtle 5]"
"pen-6" 1.0 0 -10899396 true "" "if (length [suborders_list] of turtle 6 > 0) [plot ([my_group_productivity] of turtle 6 ) / length [suborders_list] of turtle 6]"

SWITCH
1124
45
1305
78
Gray-links-Visible
Gray-links-Visible
1
1
-1000

SWITCH
96
222
186
255
AskPOS
AskPOS
0
1
-1000

SWITCH
189
222
279
255
AskNEG
AskNEG
0
1
-1000

TEXTBOX
55
19
192
37
NIL
13
0.0
1

TEXTBOX
50
14
249
32
Set these three buttons BEFORE Setup
11
0.0
1

PLOT
1108
485
1282
605
Free operators / managers
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot count turtles with [not subordinate] - managers"
"pen-1" 1.0 0 -7500403 true "" "plot count turtles with [head and (length suborders_list != 0)]"

BUTTON
53
534
242
567
InvertPerceptonOfTurtle TrtlWho
InvertPerceptonOfTurtle
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
36
106
255
125
OTHER BUTTONS HAVE EFFECT ON FLY
11
0.0
1

TEXTBOX
62
445
236
463
Perception's distribution parameters
11
0.0
1

TEXTBOX
62
119
233
137
Parameters of Individual strategy
11
0.0
1

TEXTBOX
71
208
242
226
Parameters for Head behaviour
11
0.0
1

TEXTBOX
72
387
222
405
Operator (suborder) behaviour
11
0.0
1

SLIDER
70
404
218
437
PrbltyOfDecisn%
PrbltyOfDecisn%
0
100
86.0
1
1
NIL
HORIZONTAL

SLIDER
70
259
204
292
PrbltyOfElimination%
PrbltyOfElimination%
0
100
60.0
1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

This is a model of organizational behavior in the hierarchy.
It simulates process of the formation of teams, taking into account the mutual (generally speaking - asymmetrical) perception of the Head and subordinates and changes in the group performance of the teams. 
Group performance depends on the individual performance of team members and the relative position of group members and their Heads in space. The location in space changes in accordance with the individual strategies of the behavior of agents.

## HOW IT WORKS

In a two-level hierarchical structure (consisting of the positions of managers and operators), persons holding these positions have a certain performance and the value of their own (personal) perception of each other. 

The value of the perception of each other by agents is defined as a random variable that has a normal distribution (distribution parameters are set by the control elements of the interface).

In the world of the model, which is the space of perceptions, agents implement two strategies: rapprochement with agents that perceive positively and distance from agents that perceive negatively (both can be implemented, one of these strategies, or neither, the other strategy, which makes the agent stationary). Strategies are implemented in relation to those agents that are in the radius of perception (PerRadius).

The manager (Head) forms a team of agents. The performance of the group (the sum of the individual productivities of subordinates, weighted by the distance from the leader) varies depending on the position of the agents in space and the values of their individual productivities. 

Individual productivities, in the current version of the model, are set as a random variable distributed evenly on a numerical segment from 0 to 100. The manager forms the team 1) from agents that are in (organizational) radius (Op_Radius), 2) among agents that the manager perceives positively and / or negatively (both can be implemented, one of the specified rules, or neither, which means the refusal of the command formation).

Agents can (with a certain probability, given by the variable PrbltyOfDecisn%), in case of a negative perception of the manager, leave his group permanently.



## HOW TO USE IT

The Quantity slider controls how many people are in the model, and the Managers slider controls how many Heads (no more then Quantity) are in model.

The SETUP button forms random groups.  To advance the model one step at a time, use the GO ONCE button. 
The GO button keeps the model running until ticks less then 10000.

It is possible in the model to change on the fly radii values, update the perception value across the entire population and the perception of an individual agent by its neighbors within the perception radius, and the probability values for a subordinate to make a decision about leaving the group. 
You can also change the set of strategies for moving agents and strategies for recruiting a team manager. It is possible to add a randomness factor to the movement of agents (Stoch_Motion_Speed, the default is set to 0, that is, there are no random movements).

Reports: 
Group Productivity (for groups of Heads ## 0-6, plot)
Group_Productivity_Per_Worker (for groups of Heads ## 0-6, plot)
Total number of links between agents (plot)
Free operators / managers (out of groups operators and Heads with no suborders) (plot)
Agents with positive strategy (in the World window)
Agents with negative strategy (in the World window)
Perception of the person (agent) by other persons (in the World window)
Perception of other persons (agents) by the person (in the World window)
Group Productivity of all groups (numbers in Observer window)
Suborders lists for all Heads (numbers in Observer window)


## THINGS TO NOTICE

Сharacteristic for the behavior of agents in the model is the sporadic occurrence of cyclic structures (the spatial location of agents in which the coordinates of several agents and the group performance of individual groups experience quantitative fluctuations). The appearance of such structures precedes full stabilization or, under certain initial conditions, oscillations can continue indefinitely. 

## THINGS TO TRY

The behavior of agents changes if, in the course of the experiment, disable the strategy of convergence with positively perceived agents (AskPOS switch).

The likelihood of a manager leaving the group of the least productive subordinate (PrbltyOfElimination%) and the likelihood of voluntarily leaving the group of a subordinate who has a negative perceptive boss influence (PrbltyOfDecisn%) the behavior of agents and the performance of the groups.


## EXTENDING THE MODEL

Memory of Head can be implemented by adding a list of "prohibited" subordinates. Such a list includes subordinates who have previously left the group of this Head.

The formula for calculating group performance can be changed arbitrarily. In general, group efficiency is a function of individual productivities, coordinates of group members, and their mutual perceptions.

## NETLOGO FEATURES

The world topology is a "torus".

Lists are used to memorize contacts, subordinates, and perceptual values.

Service variables (op_list op2_list op3_list v vp vpx vpy vnx vny) are used to transfer values from one context enclosed in brackets [] to another. 


## CREDITS AND REFERENCES

The model represents the first approximation to the implementation of the concept of mutual perception in the hierarchy formulated by the author in the works:
1.	Ivan Smarzhevskiy. The concept of mutual perception of persons in a hierarchy.  Journal of Economy and entrepreneurship, 2018, Vol. 12, Nom. 12, p. 1120-1124. (И.А. Смаржевский, Концепция взаимного восприятия персон, занимающих позиции в иерархической структуре. // Экономика и предпринимательство. 2018. № 12. С.1120-1124).
2.	Ivan Smarzhevskiy. The development of the concept of mutual perception of persons in a hierarchy: the dynamics of perceptions.  Journal of Economy and entrepreneurship, 2019, Vol. 13, Nom. 1, p. 830-833 (И.А. Смаржевский, Развитие концепции взаимного восприятия персон в иерархической структуре: динамика восприятий // Экономика и предпринимательство. 2019. № 1. С. 830-833.)


## HOW TO CITE

If you mention this model or the NetLogo software in a publication, we ask that you include the citations below.

For the model itself:


* Wilensky, U. (1997).  NetLogo Party model.  http://ccl.northwestern.edu/netlogo/models/Party.  Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

Please cite the NetLogo software as:

* Wilensky, U. (1999). NetLogo. http://ccl.northwestern.edu/netlogo/. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

## COPYRIGHT AND LICENSE

Copyright Ivan Smarzhevskiy 2019 

<!-- 2019 -->
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
setup
repeat 20 [ go ]
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
